VERSION 2.00
Begin Form Demo 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DDE Database Server Engine Demo"
   ClientHeight    =   1095
   ClientLeft      =   960
   ClientTop       =   2910
   ClientWidth     =   7275
   Height          =   1785
   Left            =   900
   LinkTopic       =   "Form1"
   ScaleHeight     =   1095
   ScaleWidth      =   7275
   Top             =   2280
   Width           =   7395
   Begin TextBox ErrorStat 
      Height          =   372
      Left            =   1440
      TabIndex        =   0
      Top             =   600
      Width           =   1092
   End
   Begin TextBox Message 
      Height          =   372
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   5532
   End
   Begin Label Label2 
      Alignment       =   1  'Right Justify
      BackColor       =   &H00C0C0C0&
      Caption         =   "Error status of last call:"
      Height          =   492
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1212
   End
   Begin Label Label3 
      Alignment       =   1  'Right Justify
      BackColor       =   &H00C0C0C0&
      Caption         =   "Status message:"
      Height          =   492
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   1212
   End
   Begin Menu Files 
      Caption         =   "&Files"
      Begin Menu dbfs_ 
         Caption         =   "&Databases"
         Begin Menu OpenDB 
            Caption         =   "&Open database"
         End
         Begin Menu CloseDB 
            Caption         =   "&Close database"
         End
         Begin Menu CreateDB 
            Caption         =   "C&reate database"
         End
      End
      Begin Menu ndxs_ 
         Caption         =   "&Index's"
         Begin Menu Open_Index 
            Caption         =   "&Open index"
         End
         Begin Menu Close_Index 
            Caption         =   "&Close index"
         End
         Begin Menu Create_Index 
            Caption         =   "C&reate index"
            Enabled         =   0   'False
         End
      End
      Begin Menu dbts_ 
         Caption         =   "&Memo files"
         Enabled         =   0   'False
      End
      Begin Menu sep 
         Caption         =   "-"
      End
      Begin Menu ExitDemo 
         Caption         =   "E&xit demo"
      End
   End
   Begin Menu Session 
      Caption         =   "&Session"
      Begin Menu Login 
         Caption         =   "Log&in to server"
      End
      Begin Menu Logout 
         Caption         =   "Log&out of server"
      End
   End
   Begin Menu Records 
      Caption         =   "&Records"
      Begin Menu Browser 
         Caption         =   "Browse &database "
      End
      Begin Menu ndx_bro 
         Caption         =   "Browse &index"
      End
   End
   Begin Menu Utilities 
      Caption         =   "&Utilities"
      Begin Menu Pack 
         Caption         =   "&Pack database"
         Enabled         =   0   'False
      End
      Begin Menu Zap 
         Caption         =   "&ZAP"
         Enabled         =   0   'False
      End
      Begin Menu Disp 
         Caption         =   "&Display database info"
      End
   End
End
DefInt A-Z


Sub Browser_Click ()

    '
    'Use the record browser form
    '

    Browse.Show
    
End Sub

Sub Close_Index_Click ()
    
    
    '
    'Closes an index
    '

    CloseNDX NDXHandle, Status
    
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = "index closed"
    Else
	Message.Text = "index not closed"
    End If

End Sub

Sub CloseDB_Click ()
    
    '
    'Close the open database
    '
    
    CloseDBF DBFHandle, Mode, Status
    
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = DBFName + " closed"
    Else
	Message.Text = DBFName + " not closed"
    End If

End Sub

Sub CreateDB_Click ()
    
    '
    'Create a database
    '
    

    DefineDatabase.Show 1

    '--- update demo screen
    If DBFHandle > 0 Then
	Message.Text = DBFName + " created & opened"
	ErrorStat.Text = "0"
    Else
	Message.Text = DBFName + " not created"
	ErrorStat.Text = LTrim$(Str$(DBFHandle))    'DBFHandle is modified by definedatabase to be 0 on error or else the file handle
    End If
    
End Sub

Sub Disp_Click ()
    
    DispDBInfo.Show 0

End Sub

Sub ExitDemo_Click ()
	
	'
	'End program.
	'
	
	Unload Demo
	End
	
End Sub

Sub Form_Load ()
    
    Demo.Move 1, 1
    
End Sub

Sub Login_Click ()
    
    Status = LogOnServer()
    
    Demo.SetFocus
    
    ErrorStat.Text = LTrim$(Str$(Status))
    
    If Status Then   'link not ok
	Message.Text = "client-server link established"
    Else
	Message.Text = "client-server link not established"
    End If
    
End Sub

Sub Logout_Click ()
     
    Status = LogOffServer()
    
    ErrorStat.Text = LTrim$(Str$(Status))
    
    If Status Then
	Message.Text = "Client link removed"
    Else
	Message.Text = "Client link not removed"
    End If
    
End Sub

Sub ndx_bro_Click ()
    
    BrowseNDX.Show 1

End Sub

Sub Open_Index_Click ()
    
    '
    'Opens an index file
    '

    '--- prompt for an ndx to open
    LoadFile "*.NDX", "Open Index", NDXName$
    
    '--- open index
    OpenNDX NDXHandle, Status, NDXName$, NDXtype, NDXmode, KeyExp$, KeyLen, KeyType, Mode
    
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = NDXName$ + " opened"
    Else
	Message.Text = NDXName$ + " not opened"
    End If
    

End Sub

Sub OpenDB_Click ()
    
    '
    'Open a database.
    '
    
    '--- prompt for a dbf to open; use FileForm to get DBF name
    LoadFile "*.DBF", "Open Database", FileName$
    
    OpenDBF FileHandle, Status, FileName$, 0, FileMode
    
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = FileName$ + " opened"
	DBFName = FileName$
	DBFHandle = FileHandle
    Else
	Message.Text = FileName$ + " not opened"
	DBFName = ""
	DBFHandle = 0
    End If
    
End Sub

Sub Pack_Click ()
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = FileName$ + " packed successfully"
    Else
	Message.Text = FileName$ + " not packed successfully"
    End If

End Sub

Sub Zap_Click ()
    '--- update demo screen
    ErrorStat.Text = LTrim$(Str$(Status))
    If Status = 0 Then
	Message.Text = FileName$ + " ZAP'd successfully"
    Else
	Message.Text = FileName$ + " not ZAP'd successfully"
    End If

End Sub

